
; CC5X Version 3.2, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  26. Sep 2004  13:53  *************

	processor  12F675
	radix  DEC

Zero_       EQU   2
RP0         EQU   5
GPIO        EQU   0x05
CMCON       EQU   0x19
TRISIO      EQU   0x85
ANSEL       EQU   0x9F
varlong     EQU   0x24
varchar     EQU   0x26
n1          EQU   0x20
n2          EQU   0x22
c           EQU   0x23

	GOTO main

  ; FILE flash.c
			;#pragma chip PIC12F675
			;
			;unsigned long varlong;	// une variable 8 bits et une variable 16 bits pour tempo, (demo variables) 
			;unsigned char varchar;	// attention : les int sont cods sur 8 bits
			;
			;// tempo contient deux boucles imbriquees, la duree est proportionnelle  n1*n2
			;void tempo(unsigned long n1, unsigned char n2)
			;{	unsigned char c;
tempo
	MOVWF n2
			;	while (--n1)  {
m001	DECF  n1,1
	INCF  n1,W
	BTFSC 0x03,Zero_
	DECF  n1+1,1
	MOVF  n1,W
	IORWF n1+1,W
	BTFSC 0x03,Zero_
	GOTO  m003
			;					c=n2;
	MOVF  n2,W
	MOVWF c
			;					while (--c);
m002	DECF  c,1
	BTFSC 0x03,Zero_
	GOTO  m001
	GOTO  m002
			;					}
			;}	
m003	RETURN
			;
			;void main(void)
			;{
main
			;	varlong=1000;			// valeurs produisant une tempo d'environ 0.5s
	MOVLW .232
	MOVWF varlong
	MOVLW .3
	MOVWF varlong+1
			;	varchar=100;
	MOVLW .100
	MOVWF varchar
			;	GPIO=0;
	BCF   0x03,RP0
	CLRF  GPIO
			;	CMCON=7;		// fonction comparateur desactivee
	MOVLW .7
	MOVWF CMCON
			;	ANSEL=0;		// AN0 - AN3 entrees numeriques
	BSF   0x03,RP0
	CLRF  ANSEL
			;	TRISIO=0b11001111; // pour allumer D0 sur PICKIT1
	MOVLW .207
	MOVWF TRISIO
			;	while(1) 
			;		{
			;			GPIO=0b00010000;		//D0 allumee
m004	MOVLW .16
	BCF   0x03,RP0
	MOVWF GPIO
			;			tempo(varlong,varchar);
	MOVF  varlong,W
	MOVWF n1
	MOVF  varlong+1,W
	MOVWF n1+1
	MOVF  varchar,W
	CALL  tempo
			;			GPIO=0b00000000;		//D0 eteinte
	CLRF  GPIO
			;			tempo(varlong,varchar);
	MOVF  varlong,W
	MOVWF n1
	MOVF  varlong+1,W
	MOVWF n1+1
	MOVF  varchar,W
	CALL  tempo
			;		}
	GOTO  m004

	END


; *** KEY INFO ***

; 0x0001   16 word(s)  1 % : tempo
; 0x0011   31 word(s)  3 % : main

; RAM usage: 7 bytes (4 local), 57 bytes free
; Maximum call level: 1
; Total of 48 code words (4 %)
