#pragma chip PIC12F675

unsigned long varlong;	// une variable 8 bits et une variable 16 bits pour tempo, (demo variables) 
unsigned char varchar;	// attention : les int sont cods sur 8 bits

// tempo contient deux boucles imbriquees, la duree est proportionnelle  n1*n2
void tempo(unsigned long n1, unsigned char n2)
{	unsigned char c;
	while (--n1)  {
					c=n2;
					while (--c);
					}
}	

void main(void)
{
	varlong=1000;			// valeurs produisant une tempo d'environ 0.5s
	varchar=100;
	GPIO=0;
	CMCON=7;		// fonction comparateur desactivee
	ANSEL=0;		// AN0 - AN3 entrees numeriques
	TRISIO=0b11001111; // pour allumer D0 sur PICKIT1
	while(1) 
		{
			GPIO=0b00010000;		//D0 allumee
			tempo(varlong,varchar);
			GPIO=0b00000000;		//D0 eteinte
			tempo(varlong,varchar);
		}
}

	

