
; CC5X Version 3.2, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  26. Sep 2004  13:58  *************

	processor  12F675
	radix  DEC

PCL         EQU   0x02
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
GPIO        EQU   0x05
CMCON       EQU   0x19
TRISIO      EQU   0x85
ANSEL       EQU   0x9F
varchar     EQU   0x24
varlong     EQU   0x25
i           EQU   0x27
n1          EQU   0x20
n2          EQU   0x21
cpt         EQU   0x23
ci          EQU   0x20

	GOTO main

  ; FILE ledC5.c
			;#pragma chip PIC12F675
			;const unsigned char sortie[]= {0b00010000,0b00100000,0b00010000,0b00000100,0b00100000,0b00000100,0b00000100,0b00000010};
			;const unsigned char sens[]= {0b11001111,0b11001111,0b11101011,0b11101011,0b11011011,0b11011011,0b11111001,0b11111001};
			;
			;unsigned char varchar; 	// une variable 8 bits et une 16 bits pour tempo 
			;unsigned long varlong;	// attention : les int sont cods sur 8 bits
			;unsigned char i;		// indice des tableaux
			;
			;void tempo(unsigned char n1, unsigned long n2); 
			;
			;void main(void)
			;{
_const1
	MOVWF ci
	CLRF  PCLATH
	MOVF  ci,W
	ANDLW .15
	ADDWF PCL,1
	RETLW .16
	RETLW .32
	RETLW .16
	RETLW .4
	RETLW .32
	RETLW .4
	RETLW .4
	RETLW .2
	RETLW .207
	RETLW .207
	RETLW .235
	RETLW .235
	RETLW .219
	RETLW .219
	RETLW .249
	RETLW .249
main
			;	varchar=100;		// valeurs produisant une tempo d'environ 0.5s
	MOVLW .100
	MOVWF varchar
			;	varlong=1000;
	MOVLW .232
	MOVWF varlong
	MOVLW .3
	MOVWF varlong+1
			;	GPIO=0;
	BCF   0x03,RP0
	CLRF  GPIO
			;	CMCON=7;		// fonction comparateur desactivee
	MOVLW .7
	MOVWF CMCON
			;	ANSEL=0;		// AN0 - AN3 entrees numeriques
	BSF   0x03,RP0
	CLRF  ANSEL
			;	TRISIO = 0x00;
	CLRF  TRISIO
			;	GPIO=0b00000000;	// GPIO en sortie
	BCF   0x03,RP0
	CLRF  GPIO
			;	while(1) 
			;		{
			;		for (i=0;i<8;i++)
m001	CLRF  i
m002	MOVLW .8
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m001
			;			{
			;			TRISIO=sens[i];
	MOVLW .8
	ADDWF i,W
	CALL  _const1
	BSF   0x03,RP0
	MOVWF TRISIO
			;			GPIO=sortie[i];
	MOVF  i,W
	CALL  _const1
	BCF   0x03,RP0
	MOVWF GPIO
			;			tempo(varchar,varlong);
	MOVF  varchar,W
	MOVWF n1
	MOVF  varlong,W
	MOVWF n2
	MOVF  varlong+1,W
	MOVWF n2+1
	CALL  tempo
			;			}
	INCF  i,1
	GOTO  m002
			;		}
			;}
			;	
			;void tempo(unsigned char n1, unsigned long n2)
			;{	unsigned char cpt ;
tempo
			;	while (--n1) {
m003	DECF  n1,1
	BTFSC 0x03,Zero_
	GOTO  m005
			;				cpt=n2;
	MOVF  n2,W
	MOVWF cpt
			;				while (--cpt);
m004	DECF  cpt,1
	BTFSC 0x03,Zero_
	GOTO  m003
	GOTO  m004
			;			 }
			;}
m005	RETURN

	END


; *** KEY INFO ***

; 0x003C   10 word(s)  0 % : tempo
; 0x0016   38 word(s)  3 % : main
; 0x0001   21 word(s)  2 % : _const1

; RAM usage: 8 bytes (4 local), 56 bytes free
; Maximum call level: 1
; Total of 70 code words (6 %)
