
; CC5X Version 3.2, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  28. Feb 2004  18:48  *************

	processor  12F675
	radix  DEC

PCL         EQU   0x02
PCLATH      EQU   0x0A
PSA         EQU   3
T0CS        EQU   5
Carry       EQU   0
RP0         EQU   5
T0IF        EQU   2
T0IE        EQU   5
GIE         EQU   7
GPIO        EQU   0x05
CMCON       EQU   0x19
TRISIO      EQU   0x85
ANSEL       EQU   0x9F
i           EQU   0x21
cptIT       EQU   0x22
ci          EQU   0x20

	GOTO main

  ; FILE ledITC5.c
			;#pragma chip PIC12F675
			;//#include <int16CXX.h>
			;
			;const unsigned char sortie[]={0b00010000,0b00100000,0b00010000,0b00000100,0b00100000,0b00000100,0b00000100,0b00000010};
			;const unsigned char sens[]={0b11001111,0b11001111,0b11101011,0b11101011,0b11011011,0b11011011,0b11111001,0b11111001};
			;
			;#pragma interruptSaveCheck n // pas de test d'IT, les registres W et PCLATCH ne sont pas sauvegards.
			;#pragma origin 4			// adresse d'IT sur PIC12
	ORG 0x0004
			;
			;interrupt ITtimer0(void)	// SP de traitement de l'IT TIMER0
			;{
ITtimer0
			;static unsigned char i,cptIT;	// i pointe les LED, cptIT compteur d'interruptions
			;//int_save_registers
			;if (++cptIT>=10)
	INCF  cptIT,1
	MOVLW .10
	SUBWF cptIT,W
	BTFSS 0x03,Carry
	GOTO  m001
			;	{
			;		TRISIO=sens[i];
	MOVLW .8
	ADDWF i,W
	CALL  _const1
	BSF   0x03,RP0
	MOVWF TRISIO
			;		GPIO=sortie[i];	
	MOVF  i,W
	CALL  _const1
	BCF   0x03,RP0
	MOVWF GPIO
			;		i++;
	INCF  i,1
			;		if (i>=8) i=0;
	MOVLW .8
	SUBWF i,W
	BTFSC 0x03,Carry
	CLRF  i
			;		cptIT=0;
	CLRF  cptIT
			;	}
			;	T0IF=0;
m001	BCF   0x0B,T0IF
			;//int_restore_registers // W, STATUS et PCLATH)
			;}
	RETFIE
			;
			;void main(void)
			;{
_const1
	MOVWF ci
	CLRF  PCLATH
	MOVF  ci,W
	ANDLW .15
	ADDWF PCL,1
	RETLW .16
	RETLW .32
	RETLW .16
	RETLW .4
	RETLW .32
	RETLW .4
	RETLW .4
	RETLW .2
	RETLW .207
	RETLW .207
	RETLW .235
	RETLW .235
	RETLW .219
	RETLW .219
	RETLW .249
	RETLW .249
main
			;	GPIO=0;			// pour init GPIO
	BCF   0x03,RP0
	CLRF  GPIO
			;	CMCON=7;		// finction comparateur desactivee
	MOVLW .7
	MOVWF CMCON
			;	ANSEL=0;		// AN0 - AN3 entrees numeriques
	BSF   0x03,RP0
	CLRF  ANSEL
			;	T0CS=0;			// horloge interne sur TIMER0 (dans OPTION)
	BCF   0x81,T0CS
			;	PSA=0;			// prdiviseur sur TIMER0 (dans OPTION)
	BCF   0x81,PSA
			;					// prdiviseur par 128 lors du reset
			;	T0IE=1;			// autorise IT sur dbordement TIMER0
	BSF   0x0B,T0IE
			;	GIE=1;			// autorise toutes les IT
	BSF   0x0B,GIE
			;	while(1); 
m002	GOTO  m002

	END


; *** KEY INFO ***

; 0x0004   22 word(s)  2 % : ITtimer0
; 0x001A   21 word(s)  2 % : _const1
; 0x002F   11 word(s)  1 % : main

; RAM usage: 3 bytes (1 local), 61 bytes free
; Maximum call level: 0 (+2 for interrupt)
; Total of 55 code words (5 %)
