
; CC5X Version 3.2, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  10. Mar 2004  16:07  *************

	processor  12F675
	radix  DEC

Carry       EQU   0
Zero_       EQU   2
FpOverflow  EQU   1
FpUnderFlow EQU   2
FpDiv0      EQU   3
FpRounding  EQU   6
arg1f24     EQU   0x20
arg2f24     EQU   0x23
aarg        EQU   0x26
sign        EQU   0x28
counter     EQU   0x29
aarg_2      EQU   0x26
sign_2      EQU   0x28
counter_2   EQU   0x29
a           EQU   0x2B
b           EQU   0x2E
c           EQU   0x31
d           EQU   0x34

	GOTO main

  ; FILE C:\CC5demo\math24f.h
			;// *************************************************
			;// 24 bit basic floating point math operations
			;// Copyright (c) B Knudsen Data, Norway, 2000 - 2001
			;// *************************************************
			;
			;#pragma library 1
			;/* PROTOTYPES for page definition in application header file:
			;float24 operator* _fmul24( float24 arg1f24, float24 arg2f24);
			;float24 operator/ _fdiv24( float24 arg1f24, float24 arg2f24);
			;float24 operator+ _fadd24( float24 arg1f24, float24 arg2f24);
			;float24 operator- _fsub24( float24 arg1f24, float24 arg2f24);
			;float24 operator= _int24ToFloat24( int24 arg1f24);
			;float24 operator= _int32ToFloat24( int32 arg32);
			;int24 operator= _float24ToInt24( float24 arg1f24);
			;bit operator< _f24_LT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator>= _f24_GE_f24( float24 arg1f24, float24 arg2f24);
			;bit operator> _f24_GT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator<= _f24_LE_f24( float24 arg1f24, float24 arg2f24);
			;*/
			;
			;// DEFINABLE SYMBOLS (in the application code):
			;//#define FP_OPTIM_SPEED  // optimize for SPEED: default
			;//#define FP_OPTIM_SIZE   // optimize for SIZE
			;//#define DISABLE_ROUNDING   // disable rounding and save code space
			;
			;#define float24ToIEEE754(a) { a.mid8=rl(a.mid8); a.high8=rr(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;#define IEEE754ToFloat24(a) { a.mid8=rl(a.mid8); a.high8=rl(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;
			;
			;/*  24 bit floating point format:
			;
			;  address  ID
			;    X      a.low8  : LSB, bit 0-7 of mantissa
			;    X+1    a.mid8  : bit 8-14 of mantissa, bit 15 is the sign bit
			;    X+2    a.high8 : MSB, bit 0-7 of exponent, with bias 0x7F
			;
			;    bit 15 of mantissa is a hidden bit, always equal to 1
			;    zero (0.0) :  a.high8 = 0 (mantissa & sign ignored)
			;
			;   MSB    LSB
			;    7F 00 00  : 1.0   =  1.0  * 2**(0x7F-0x7F) = 1.0 * 1
			;    7F 80 00  : -1.0  = -1.0  * 2**(0x7F-0x7F) = -1.0 * 1
			;    80 00 00  : 2.0   =  1.0  * 2**(0x80-0x7F) = 1.0 * 2
			;    80 40 00  : 3.0   =  1.5  * 2**(0x80-0x7F) = 1.5 * 2
			;    7E 60 00  : 0.875 =  1.75 * 2**(0x7E-0x7F) = 1.75 * 0.5
			;    7F 60 00  : 1.75  =  1.75 * 2**(0x7E-0x7F) = 1.75 * 1
			;    7F 7F FF  : 1.999969482
			;    00 7C 5A  : 0.0 (mantissa & sign ignored)
			;    01 00 00  : 1.17549435e-38 =  1.0 * 2**(0x01-0x7F)
			;    FE 7F FF  : 3.40277175e+38 =  1.999969482 * 2**(0xFE-0x7F)
			;    FF 00 00  : +INF : positive infinity
			;    FF 80 00  : -INF : negative infinity
			;*/                 
			;
			;#define  FpBIAS  0x7F
			;
			;#ifndef FpFlags_defined
			; #define FpFlags_defined
			;
			; char FpFlags;
			; //bit IOV         @ FpFlags.0; // integer overflow flag: NOT USED
			; bit FpOverflow    @ FpFlags.1; // floating point overflow flag
			; bit FpUnderFlow   @ FpFlags.2; // floating point underflow flag
			; bit FpDiv0        @ FpFlags.3; // floating point divide by zero flag
			; //bit FpNAN       @ FpFlags.4; // not-a-number exception flag: NOT USED
			; bit FpDomainError @ FpFlags.5; // domain error exception flag
			; bit FpRounding    @ FpFlags.6; // floating point rounding flag, 0=truncation
			;                                // 1 = unbiased rounding to nearest LSB
			; //bit FpSaturate  @ FpFlags.7; // floating point saturate flag: NOT USED
			;
			; #pragma floatOverflow FpOverflow
			; #pragma floatUnderflow FpUnderFlow
			;
			; #define InitFpFlags()  FpFlags = 0x40 /* enable rounding as default */
			;#endif
			;
			;#ifdef DISABLE_ROUNDING
			; #pragma floatRounding 0
			;#endif
			;
			;
			;#if __CoreSet__ < 1600
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W;
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W;
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W;
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W;
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r);
			; #define genSub(r,a) W=a; r=subWFB(r);
			; #define genAddW(r,a) W=a; W=addWFC(r);
			; #define genSubW(r,a) W=a; W=subWFB(r);
			;#endif
			;
			;
			;
			;float24 operator* _fmul24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fmul24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
	MOVF  arg1f24+1,W
			;    aarg.high8 = W;
	MOVWF aarg+1
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
	XORWF arg2f24+1,W
	MOVWF sign
			;
			;    W = arg1f24.high8;
	MOVF  arg1f24+2,W
			;    if ( !Zero_)
	BTFSS 0x03,Zero_
			;        W = arg2f24.high8;
	MOVF  arg2f24+2,W
			;    if ( Zero_)
	BTFSC 0x03,Zero_
			;        goto RES0;
	GOTO  m007
			;
			;    arg1f24.high8 += W /* arg2f24.high8 */;
	ADDWF arg1f24+2,1
			;    W = FpBIAS-1;
	MOVLW .126
			;    if ( Carry)  {
	BTFSS 0x03,Carry
	GOTO  m001
			;        arg1f24.high8 -= W;
	SUBWF arg1f24+2,1
			;        if ( Carry)
	BTFSS 0x03,Carry
	GOTO  m002
			;            goto OVERFLOW;
	GOTO  m008
			;    }
			;    else  {
			;        arg1f24.high8 -= W;
m001	SUBWF arg1f24+2,1
			;        if ( !Carry)
	BTFSS 0x03,Carry
			;            goto UNDERFLOW;
	GOTO  m006
			;    }
			;    aarg.low8 = arg1f24.low8;
m002	MOVF  arg1f24,W
	MOVWF aarg
			;
			;    aarg.15 = 1;
	BSF   aarg+1,7
			;    arg2f24.15 = 1;
	BSF   arg2f24+1,7
			;
			;    arg1f24.low16 = 0;
	CLRF  arg1f24
	CLRF  arg1f24+1
			;
			;    char counter = sizeof(aarg)*8;
	MOVLW .16
	MOVWF counter
			;
			;    do  {
			;        aarg = rr( aarg);
m003	RRF   aarg+1,1
	RRF   aarg,1
			;        if ( Carry)  {
	BTFSS 0x03,Carry
	GOTO  m004
			;            arg1f24.low8 += arg2f24.low8;
	MOVF  arg2f24,W
	ADDWF arg1f24,1
			;            genAdd( arg1f24.mid8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSC 0x03,Carry
	INCFSZ arg2f24+1,W
	ADDWF arg1f24+1,1
			;        }
			;        arg1f24.low16 = rr( arg1f24.low16);
m004	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;    } while ( -- counter > 0);
	DECFSZ counter,1
	GOTO  m003
			;
			;    if ( !arg1f24.15)  {
	BTFSC arg1f24+1,7
	GOTO  m005
			;        // catch Carry bit that was shifted out previously
			;        arg1f24.low16 = rl( arg1f24.low16);
	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;        if ( arg1f24.high8 == 0)
	MOVF  arg1f24+2,1
	BTFSC 0x03,Zero_
			;            goto UNDERFLOW;
	GOTO  m006
			;        arg1f24.high8 -= 1;
	DECF  arg1f24+2,1
			;        W = rl( aarg.high8);
	RLF   aarg+1,W
			;        // restore bit behind LSB in Carry
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding  &&  Carry)  {
m005	BTFSS 0x2A,FpRounding
	GOTO  m010
	BTFSS 0x03,Carry
	GOTO  m010
			;        arg1f24.low8 += 1;
	INCFSZ arg1f24,1
			;        if ( !arg1f24.low8)  {
	GOTO  m010
			;            arg1f24.mid8 += 1;
	INCFSZ arg1f24+1,1
			;            if ( !arg1f24.mid8)  {
	GOTO  m010
			;                // Carry = 1; //OK
			;                arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;                arg1f24.high8 += 1;
	INCFSZ arg1f24+2,1
			;                if ( Zero_)
	GOTO  m010
			;                    goto OVERFLOW;
	GOTO  m008
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
m006	BSF   0x2A,FpUnderFlow
			;  RES0:
			;    arg1f24.high8 = 0;
m007	CLRF  arg1f24+2
			;    goto MANTISSA;
	GOTO  m009
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
m008	BSF   0x2A,FpOverflow
			;    arg1f24.high8 = 0xFF;
	MOVLW .255
	MOVWF arg1f24+2
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
m009	CLRF  arg1f24
	MOVLW .128
	MOVWF arg1f24+1
			;
			;  SET_SIGN:
			;    if ( !(sign & 0x80))
m010	BTFSS sign,7
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;    return arg1f24;
	MOVF  arg1f24,W
	RETURN
			;}
			;
			;
			;
			;float24 operator/ _fdiv24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fdiv24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
	MOVF  arg1f24+1,W
			;    aarg.high8 = W;
	MOVWF aarg_2+1
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
	XORWF arg2f24+1,W
	MOVWF sign_2
			;
			;    W = arg2f24.high8;
	MOVF  arg2f24+2,W
			;    if ( Zero_)
	BTFSC 0x03,Zero_
			;        goto Div0;
	GOTO  m021
			;    if ( !arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSC 0x03,Zero_
			;        goto RES0;
	GOTO  m023
			;
			;    arg1f24.high8 -= arg2f24.high8;
	MOVF  arg2f24+2,W
	SUBWF arg1f24+2,1
			;    W = FpBIAS;
	MOVLW .127
			;    if ( !Carry)  {
	BTFSC 0x03,Carry
	GOTO  m011
			;        arg1f24.high8 += W;
	ADDWF arg1f24+2,1
			;        if ( !Carry)
	BTFSC 0x03,Carry
	GOTO  m012
			;            goto UNDERFLOW;
	GOTO  m022
			;    }
			;    else  {
			;        arg1f24.high8 += W;
m011	ADDWF arg1f24+2,1
			;        if ( Carry)
	BTFSC 0x03,Carry
			;            goto OVERFLOW;
	GOTO  m024
			;    }
			;
			;    aarg.low8 = arg1f24.low8;
m012	MOVF  arg1f24,W
	MOVWF aarg_2
			;    aarg.15 = 1;
	BSF   aarg_2+1,7
			;    arg2f24.15 = 1;
	BSF   arg2f24+1,7
			;
			;    // division: shift & add
			;    char counter = 16;
	MOVLW .16
	MOVWF counter_2
			;    arg1f24.low16 = 0;  // speedup
	CLRF  arg1f24
	CLRF  arg1f24+1
			;
			;#if defined FP_OPTIM_SPEED || !defined FP_OPTIM_SIZE  // SPEED
			;
			;    goto START;
	GOTO  m015
			;
			;  TEST_ZERO_L:
			;    W = aarg.low8 - arg2f24.low8;
m013	MOVF  arg2f24,W
	SUBWF aarg_2,W
			;    if (!Carry)
	BTFSS 0x03,Carry
			;        goto SHIFT_IN_CARRY;
	GOTO  m018
			;    aarg.low8 = W;
	MOVWF aarg_2
			;    aarg.high8 = 0;
	CLRF  aarg_2+1
			;    goto SET_AND_SHIFT_IN_CARRY;
	GOTO  m017
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP:
			;        if (!Carry)  {
m014	BTFSC 0x03,Carry
	GOTO  m016
			;           START:
			;            W = aarg.high8 - arg2f24.mid8;
m015	MOVF  arg2f24+1,W
	SUBWF aarg_2+1,W
			;            if ( Zero_)
	BTFSC 0x03,Zero_
			;                goto TEST_ZERO_L;
	GOTO  m013
			;            if ( !Carry)
	BTFSS 0x03,Carry
			;                goto SHIFT_IN_CARRY;
	GOTO  m018
			;        }
			;        aarg.low8 -= arg2f24.low8;
m016	MOVF  arg2f24,W
	SUBWF aarg_2,1
			;        genSub( aarg.high8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2f24+1,W
	SUBWF aarg_2+1,1
			;      SET_AND_SHIFT_IN_CARRY:
			;        Carry = 1;
m017	BSF   0x03,Carry
			;      SHIFT_IN_CARRY:
			;        arg1f24.low16 = rl( arg1f24.low16);
m018	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;        // Carry = 0;  // ok, speedup
			;        aarg = rl( aarg);
	RLF   aarg_2,1
	RLF   aarg_2+1,1
			;    } while ( -- counter > 0);
	DECFSZ counter_2,1
	GOTO  m014
			;
			;
			;
			;#else  // SIZE
			;
			;    goto START;
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP:
			;        if ( Carry)
			;            goto SUBTRACT;
			;      START:
			;        W = aarg.low8 - arg2f24.low8;
			;        genSubW( aarg.high8, arg2f24.mid8);
			;        if (!Carry)
			;            goto SKIP_SUB;
			;       SUBTRACT:
			;        aarg.low8 -= arg2f24.low8;
			;        genSub( aarg.high8, arg2f24.mid8);
			;        Carry = 1;
			;       SKIP_SUB:
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        // Carry = 0;  // ok
			;        aarg = rl( aarg);
			;    } while ( -- counter > 0);
			;
			;#endif
			;
			;    if ( !arg1f24.15)  {
	BTFSC arg1f24+1,7
	GOTO  m019
			;        if ( !arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSC 0x03,Zero_
			;            goto UNDERFLOW;
	GOTO  m022
			;        arg1f24.high8 --;
	DECF  arg1f24+2,1
			;        counter ++;
	INCF  counter_2,1
			;        goto LOOP;
	GOTO  m014
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding)  {
m019	BTFSS 0x2A,FpRounding
	GOTO  m027
			;        if ( Carry)
	BTFSC 0x03,Carry
			;            goto ADD_1;
	GOTO  m020
			;        aarg.low8 -= arg2f24.low8;
	MOVF  arg2f24,W
	SUBWF aarg_2,1
			;        genSub( aarg.high8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2f24+1,W
	SUBWF aarg_2+1,1
			;        if (Carry)  {
	BTFSS 0x03,Carry
	GOTO  m027
			;          ADD_1:
			;            arg1f24.low8 += 1;
m020	INCFSZ arg1f24,1
			;            if ( !arg1f24.low8)  {
	GOTO  m027
			;                arg1f24.mid8 ++;
	INCFSZ arg1f24+1,1
			;                if ( !arg1f24.mid8)  {
	GOTO  m027
			;                    arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;                    arg1f24.high8 ++;
	INCFSZ arg1f24+2,1
			;                    if ( !arg1f24.high8)
	GOTO  m027
			;                        goto OVERFLOW;
	GOTO  m024
			;                }
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
			;
			;  Div0:
			;    FpDiv0 = 1;
m021	BSF   0x2A,FpDiv0
			;    goto SATURATE;
	GOTO  m025
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
m022	BSF   0x2A,FpUnderFlow
			;  RES0:
			;    arg1f24.high8 = 0;
m023	CLRF  arg1f24+2
			;    goto MANTISSA;
	GOTO  m026
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
m024	BSF   0x2A,FpOverflow
			;  SATURATE:
			;    arg1f24.high8 = 0xFF;
m025	MOVLW .255
	MOVWF arg1f24+2
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
m026	CLRF  arg1f24
	MOVLW .128
	MOVWF arg1f24+1
			;
			;  SET_SIGN:
			;    if ( !(sign & 0x80))
m027	BTFSS sign_2,7
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;    return arg1f24;
	MOVF  arg1f24,W
	RETURN
			;}
			;
			;
			;float24 operator+ _fadd24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fadd24
			;    char xtra, temp;
			;    char expo = arg1f24.high8 - arg2f24.high8;
			;    if ( !Carry)  {
			;        expo = -expo;
			;        temp = arg1f24.high8;
			;        arg1f24.high8 = arg2f24.high8;
			;        arg2f24.high8 = temp;
			;        temp = arg1f24.mid8;
			;        arg1f24.mid8 = arg2f24.mid8;
			;        arg2f24.mid8 = temp;
			;        temp = arg1f24.low8;
			;        arg1f24.low8 = arg2f24.low8;
			;        arg2f24.low8 = temp;
			;    }
			;    if ( expo > sizeof(arg1f24)*8-7)
			;        goto RETURN;
			;    if ( !arg2f24.high8)
			;        goto RETURN;   // result is arg1f24
			;
			;    xtra = 0;
			;
			;    temp = arg1f24.mid8;
			;    char sign = arg2f24.mid8 ^ arg1f24.mid8;
			;    arg1f24.15 = 1;
			;    arg2f24.15 = 1;
			;
			;    while (1)  {
			;        W = 8;
			;        expo -= W;
			;        if ( !Carry)
			;            break;
			;        xtra = arg2f24.low8;
			;        arg2f24.low8 = arg2f24.mid8;
			;        arg2f24.mid8 = 0;
			;    }
			;    expo += W;
			;    if ( expo)  {
			;        do  {
			;            Carry = 0;
			;            arg2f24.low16 = rr( arg2f24.low16);
			;            xtra = rr( xtra);
			;        } while (--expo > 0);
			;    }
			;
			;
			;    if ( sign & 0x80)  {
			;        // SUBTRACT
			;        arg1f24.low8 -= arg2f24.low8;
			;        genSub( arg1f24.mid8, arg2f24.mid8);
			;        if (!Carry)  {  // arg2f24 > arg1f24
			;            arg1f24.low16 = -arg1f24.low16;
			;            // xtra == 0 because arg1f24.exp == arg2f24.exp
			;            temp ^= 0x80;  // invert sign
			;        }
			;        xtra = -xtra;
			;        if ( xtra)
			;            arg1f24.low16 --;
			;        // adjust result left
			;       #define counter expo
			;        counter = 3;
			;        while ( !arg1f24.mid8)  {
			;            arg1f24.mid8 = arg1f24.low8;
			;            arg1f24.low8 = xtra;
			;            xtra = 0;
			;            arg1f24.high8 -= 8;
			;            if ( !Carry)
			;                goto RES0;
			;            if ( --counter == 0)  // max 2 iterations
			;                goto RES0;
			;        }
			;       #undef counter
			;        while ( !arg1f24.15)  {
			;            Carry = 0;
			;            xtra = rl( xtra);
			;            arg1f24.low16 = rl( arg1f24.low16);
			;            arg1f24.high8 --;
			;            if ( !arg1f24.high8)
			;                goto RES0;   // UNDERFLOW?
			;        }
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding  &&  (xtra & 0x80))  {
			;            xtra = 0; // disable recursion
			;            goto INCREMENT;
			;        }
			;       #endif
			;    }
			;    else  {
			;        // ADD arg1f24 and arg2f24
			;        arg1f24.low8 += arg2f24.low8;
			;        genAdd( arg1f24.mid8, arg2f24.mid8);
			;        if ( Carry)  {
			;          ADJUST_RIGHT:
			;            arg1f24.low16 = rr( arg1f24.low16);
			;            xtra = rr( xtra);
			;            arg1f24.high8 += 1;  // exp
			;            if ( !arg1f24.high8)
			;                goto OVERFLOW;
			;        }
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding  &&  (xtra & 0x80))  {
			;          INCREMENT:
			;            arg1f24.low8 += 1;
			;            if ( !arg1f24.low8)  {
			;                arg1f24.mid8 += 1;
			;                if ( !arg1f24.mid8)  {
			;                    Carry = 1; // prepare for shift
			;                    arg1f24.0 = 0;  // disable recursion
			;                    goto ADJUST_RIGHT;
			;                }
			;            }
			;        }
			;       #endif
			;    }
			;    goto SET_SIGN;
			;
			;//  UNDERFLOW:
			;//    FpUnderFlow = 1;
			;  RES0:
			;    arg1f24.high8 = 0;
			;    goto MANTISSA;
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;    arg1f24.high8 = 0xFF;
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
			;
			;  SET_SIGN:
			;    if ( !(temp & 0x80))
			;        arg1f24.15 = 0;
			;
			;  RETURN:
			;    return arg1f24;
			;}
			;
			;
			;// SUBTRACTION
			;
			;float24 operator- _fsub24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fsub24
			;    arg2f24.mid8 ^= 0x80;
			;    arg1f24 += arg2f24;
			;    return arg1f24;
			;}
			;
			;
			;float24 operator=( int8 arg) @
			;float24 operator=( uns8 arg) @
			;float24 operator=( int16 arg) @
			;float24 operator=( uns16 arg) @
			;float24 operator= _int24ToFloat24( sharedM int24 arg1f24)
			;{
_int24ToFloat24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char expo = FpBIAS + 16 - 1;
			;    char sign = 0;
			;    if ( arg1f24 < 0)  {
			;        arg1f24 = -arg1f24;
			;        sign |= 0x80;
			;    }
			;    if ( arg1f24.high8)  {
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding && (arg1f24.low8 & 0x80))  {
			;            arg1f24.mid8 += 1;
			;            if ( !arg1f24.mid8)  {
			;                arg1f24.high8 += 1;
			;                if ( !arg1f24.high8)  {
			;                    Carry = 1;
			;                    arg1f24.high16 = rr( arg1f24.high16);
			;                    expo ++;
			;                }
			;            }
			;        }
			;       #endif
			;        expo += 8;
			;        arg1f24.low8 = arg1f24.mid8;
			;        arg1f24.mid8 = arg1f24.high8;
			;    }
			;    else if ( !arg1f24.midL8)  {
			;        expo -= 8;
			;        W = arg1f24.low8;
			;        if ( !W)
			;            goto RETURN;
			;        arg1f24.mid8 = W;
			;        arg1f24.low8 = 0;
			;    }
			;
			;    // arg1f24.mid8 != 0
			;    goto TEST_ARG1_B15;
			;    do  {
			;        Carry = 0;
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        expo --;
			;      TEST_ARG1_B15:
			;    } while ( !arg1f24.15);
			;
			;    arg1f24.high8 = expo;
			;    if ( !(sign & 0x80))
			;        arg1f24.15 = 0;
			;
			;  RETURN:
			;    float24 rval @ arg1f24;
			;    rval.low24 = arg1f24.low24;
			;    return rval;
			;}
			;
			;
			;float24 operator=( uns24 arg) @
			;float24 operator= _int32ToFloat24( int32 arg32)
			;{
_int32ToFloat24
			;    char expo = FpBIAS + 16 - 1;
			;    char sign = 0;
			;    if ( arg32 < 0)  {
			;        arg32 = -arg32;
			;        sign |= 0x80;
			;    }
			;    if ( arg32.high8)  {
			;        expo += 8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;        arg32.midH8 = arg32.high8;
			;    }
			;    if ( arg32.midH8)  {
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding && (arg32.low8 & 0x80))  {
			;            arg32.mid8 += 1;
			;            if ( !arg32.mid8)  {
			;                arg32.high8 += 1;
			;                if ( !arg32.high8)  {
			;                    Carry = 1;
			;                    arg32.high16 = rr( arg32.high16);
			;                    expo ++;
			;                }
			;            }
			;        }
			;       #endif
			;        expo += 8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;    }
			;    else if ( !arg32.midL8)  {
			;        expo -= 8;
			;        W = arg32.low8;
			;        if ( !W)
			;            goto RETURN;
			;        arg32.midL8 = W;
			;        arg32.low8 = 0;
			;    }
			;
			;    // arg32.mid8 != 0
			;    goto TEST_ARG_B15;
			;    do  {
			;        Carry = 0;
			;        arg32.low16 = rl( arg32.low16);
			;        expo --;
			;      TEST_ARG_B15:
			;    } while ( !arg32.15);
			;
			;    arg32.midH8 = expo;
			;    if ( !(sign & 0x80))
			;        arg32.15 = 0;
			;
			;  RETURN:
			;    float24 rval @ arg32;
			;    rval.low24 = arg32.low24;
			;    return rval;
			;}
			;
			;
			;uns8 operator=( sharedM float24 arg1f24) @
			;int8 operator=( sharedM float24 arg1f24) @
			;uns16 operator=( sharedM float24 arg1f24) @
			;int16 operator=( sharedM float24 arg1f24) @
			;int24 operator= _float24ToInt24( sharedM float24 arg1f24)
			;{
_float24ToInt24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char sign = arg1f24.mid8;
			;    char expo = arg1f24.high8 - FpBIAS;
			;    if ( !Carry)
			;        goto RES0;
			;    arg1f24.15 = 1;
			;
			;    arg1f24.high8 = 0;
			;   #ifndef DISABLE_ROUNDING
			;    char xtra = 0;
			;   #endif
			;
			;    // (a): expo = 0..7 : shift 1 byte to the right
			;    // (b): expo = 8..15: shift 0 byte
			;    // (c): expo = 16..23: shift 1 byte to the left
			;   #if __CoreSet__ / 100 == 12
			;    expo -= 16;
			;    expo = 0xFF - expo;  // COMF (Carry unchanged)
			;    if ( Carry)  {  // (c)
			;   #else
			;    expo = 15 - expo;
			;    if ( !Carry)  {  // (c)
			;   #endif
			;        expo += 8;
			;        if (!Carry)
			;            goto OVERFLOW;
			;        arg1f24.high8 = arg1f24.mid8;
			;        arg1f24.mid8 = arg1f24.low8;
			;        arg1f24.low8 = 0;
			;    }
			;    else  {  // (a) (b)
			;        // expo = 0 .. 15
			;        W = expo - 8;
			;        if ( Carry)  {  // (a)
			;            expo = W;
			;           #ifndef DISABLE_ROUNDING
			;            xtra = arg1f24.low8;
			;           #endif
			;            arg1f24.low8 = arg1f24.mid8;
			;            arg1f24.mid8 = 0;
			;        }
			;    }
			;    if ( expo)  {
			;        do  {
			;            Carry = 0;
			;            arg1f24.high8 = rr( arg1f24.high8);
			;            arg1f24.low16 = rr( arg1f24.low16);
			;           #ifndef DISABLE_ROUNDING
			;            xtra = rr( xtra);
			;           #endif
			;        } while ( --expo);
			;    }
			;    if (arg1f24.23)
			;        goto OVERFLOW;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding && (xtra & 0x80))  {
			;        arg1f24.low8 += 1;
			;        if (!arg1f24.low8)  {
			;            arg1f24.mid8 += 1;
			;            if (!arg1f24.mid8)  {
			;                arg1f24.high8 += 1;
			;                if (arg1f24.23)
			;                    goto OVERFLOW;
			;            }
			;        }
			;    }
			;   #endif
			;    if ( sign & 0x80)
			;        arg1f24.low24 = -arg1f24.low24;
			;    goto RETURN;
			;
			;  RES0:
			;    W = 0;
			;    goto ASSIGNW;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;    W = 0xFF;
			;  ASSIGNW:
			;    arg1f24.high8 = W;
			;    arg1f24.mid8 = W;
			;    arg1f24.low8 = W;
			;    arg1f24.23 = 0;
			;
			;  RETURN:
			;    int24 rval @ arg1f24;
			;    rval = arg1f24.low24;
			;    return rval;
			;}
			;
			;
			;bit operator< _f24_LT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LT_f24
			;    Carry = 0;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        goto RETURN;
			;    }
			;    if ( !arg2f24.15)
			;        goto RETURN;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;  RETURN:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;bit operator>= _f24_GE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GE_f24
			;    Carry = 1;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        return Carry;
			;    }
			;    Carry = 0;
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;    return Carry;
			;}
			;
			;
			;
			;bit operator> _f24_GT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GT_f24
			;    Carry = 0;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            goto RETURN;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        goto RETURN;
			;    }
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;  RETURN:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;
			;bit operator<= _f24_LE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LE_f24
			;    Carry = 1;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        Carry = 0;
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        return Carry;
			;    }
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;    return Carry;

  ; FILE tstfloat.c
			;// tests sur nombres rels sir PIC12
			;#pragma chip PIC12F675
			;#include <math24f.h> // attention le format des reels n'est pas IEEE
			;float a,b,c,d;
			;
			;void main(void)
			;{
main
			;a=2.0;			// a et b ne sont pas visibles dans MPLAB car non IEEE
	CLRF  a
	CLRF  a+1
	MOVLW .128
	MOVWF a+2
			;b=3.0;
	CLRF  b
	MOVLW .64
	MOVWF b+1
	MOVLW .128
	MOVWF b+2
			;c=a*b;
	MOVF  a,W
	MOVWF arg1f24
	MOVF  a+1,W
	MOVWF arg1f24+1
	MOVF  a+2,W
	MOVWF arg1f24+2
	MOVF  b,W
	MOVWF arg2f24
	MOVF  b+1,W
	MOVWF arg2f24+1
	MOVF  b+2,W
	MOVWF arg2f24+2
	CALL  _fmul24
	MOVF  arg1f24,W
	MOVWF c
	MOVF  arg1f24+1,W
	MOVWF c+1
	MOVF  arg1f24+2,W
	MOVWF c+2
			;float24ToIEEE754(c);  // c est maintenant au format IEEE et visualisable
	RLF   c+1,1
	RRF   c+2,1
	RRF   c+1,1
			;d=a/b;
	MOVF  a,W
	MOVWF arg1f24
	MOVF  a+1,W
	MOVWF arg1f24+1
	MOVF  a+2,W
	MOVWF arg1f24+2
	MOVF  b,W
	MOVWF arg2f24
	MOVF  b+1,W
	MOVWF arg2f24+1
	MOVF  b+2,W
	MOVWF arg2f24+2
	CALL  _fdiv24
	MOVF  arg1f24,W
	MOVWF d
	MOVF  arg1f24+1,W
	MOVWF d+1
	MOVF  arg1f24+2,W
	MOVWF d+2
			;float24ToIEEE754(d);  
	RLF   d+1,1
	RRF   d+2,1
	RRF   d+1,1
			;while(1); 
m028	GOTO  m028

	END


; *** KEY INFO ***

; 0x0001   77 word(s)  7 % : _fmul24
; 0x004E  103 word(s) 10 % : _fdiv24
; 0x00B5   54 word(s)  5 % : main

; RAM usage: 23 bytes (10 local), 41 bytes free
; Maximum call level: 1
; Total of 235 code words (22 %)
