#include <p18f452.h>



char eeplit(unsigned char * ad)		// lecture de l'adresse ad
{
	EEADR=(unsigned int)ad;
	EECON1bits.EEPGD=0;
	EECON1bits.RD=1;		
	return(EEDATA);
}

void eepecr(unsigned char * ad,unsigned char c) // ecrit  c  l'adresse ad
{
	EEADR=(unsigned int)ad;
	EEDATA=c;
	
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	EECON1bits.WREN=0;
}

// crit une chaine p  l'adresse ad en EEPROM
void eepmess(unsigned char * ad, unsigned char *p) 
{
	while (*p) eepecr(ad++,*p++);
}

/* Petit programme de test
void main(void)
{
char chaine1[]="j'ecris en EEPROM";
char *chaine2;
unsigned int * adresse;

	eepmess(0,chaine1);	
	adresse=0x0;
	while(*chaine2++=eeplit(adresse++));
	while(1);	
	
}
*/
