// acquisition de la tension sur AN0
#include <p18f252.h>
#define q 4.8828e-3	// quantum pour un CAN 10bits 0v-5v

void init_can(void)
{
	ADCON0=1;				// CAN on. CLOCK=FOSC/2. CANAL0 (RA)
	ADCON1=0b10001110;	// justification  droite, seul AN0 est activ, VREF+=VDD VREF-=VSS
}

unsigned int mesvolt(void)
{		
		ADCON0bits.GO_DONE=1;		// SOC
		while(ADCON0bits.GO_DONE);	// attend EOC
		return (ADRES);				// calcule la tension
}

/* programme de test
void main(void)
{	
float res;
	init_can();
	while(1){
			res=(float)(mesvolt())*q;
			}
}
*/
