/* gestion I2C HARD sur PIC18     C.Dupaty 01/2003
/* test de la librairie libpd2*/
#include <p18f452.h>

#include "initxlcd.c"
#include <libpd2.h>		// fonctions I2C
#include <stdlib.h>		 // pour btoa

#define adrtc74 0b1001101	// adresse HARD TC74 Microchip
#define regtemp 0			// adresse interne registre de temprature TC74
#define config 1			// adresse interne registre de configuration TC74

signed char temp;			// variable temprature
unsigned char tampon[3];		// mmoire pour les chaines converties avec BTOA 

void main(void)
{
 	OpenXLCD(FOUR_BIT & LINES_5X7 );	
 
 init_i2c();
 
while (1)
	{
	while(!(lit_i2c(adrtc74,config)&0b01000000));	// attend mesure ok (Bit D6 (du registre CONFIG TC74) =1)
	temp=lit_i2c(adrtc74,regtemp);			// le rsultat est direct (cod signed char), voir doc TC74
	
    SetDDRamAddr(0);
    putsXLCD(btoa(temp,tampon));	// crit un byte  (8 bits)
    putchar('c');
	}
}
