/*librairie pour afficheur LCD sur PICDEM2+
pour MCC18 v.2.40
*/
#include <xlcd.h>		//putcXLCD
#include <delays.h>
#include <stdio.h>		//stdout _user_putc
#include <lcd_pd2.h>

// Temporisation ncessaires aux composants de la bibliothque XLCD
void DelayFor18TCY(void) 
{
Delay10TCYx(2);
}
void DelayPORXLCD(void)
{
Delay1KTCYx(15); //Delai de 15 ms
}
void DelayXLCD(void)
{
Delay1KTCYx(20); //Delai de 20 ms
}

// initialise l'afficheur pour PICDEM2+ pour printf
void init_printf_LCDPD2(void)
{
stdout=_H_USER;		// redirige stdout (printf) vers la sortie utilisateur (_user_putc)
OpenXLCD(FOUR_BIT & LINES_5X7 );
gotoxy(0,0);	// positionne le curseur en x,y
}



