/* CD 01/2003*/
/*	gestion d'un table , application sur PIC DEM 2+*/
#include <p18f452.h>
#define tbltaille 16	// taille de la table

// exemple d'utilisation d'un tableau de constantes en ROM ! 
// seuls les 4 bits de poids faibles du PORTB commandent des LEDs

const rom unsigned char sortie[]={	0b00000000,
									0b00000001,
									0b00000010,
									0b00000100,
									0b00001000,
									0b00000100,
									0b00000010,
									0b00000001,		
									0b00000000,
									0b00000001,
									0b00000011,
									0b00000111,
									0b00001111,
									0b00001110,
									0b00001100,
									0b00001000,									
												 };

void wait(int cnt)
{
	for (;cnt>0; cnt--);
}

void main(void)
{	char c=0;
	TRISB = 0;			/* PB =	 sortie */
	while(1) 						// boucle infinie
	{ 
		for(c=0;c<tbltaille;c++)
			{
				PORTB=sortie[c];	// c indexe la table
				wait(5000);
			}
	}
}
