#include <p18C452.h>
#include <capture.h>
#include <timers.h>
#include <usart.h>
#include <stdlib.h>
void main(void)
{
unsigned int result;
char str[7];
// Configure Capture1
OpenCapture1( C1_EVERY_4_RISE_EDGE & CAPTURE_INT_OFF );
// Configure Timer3
OpenTimer3( TIMER_INT_OFF & T3_SOURCE_INT );
// Configure USART
OpenUSART( USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX,25 );
while(!PIR1bits.CCP1IF); // Wait for event
result = ReadCapture1(); // read result
ultoa(result,str); // convert to string
// Write the string out to the USART if
// an overflow condition has not occurred.
if(!CapStatus.Cap1OVF)
{
putsUSART(str);
}
// Clean up
CloseCapture1();
CloseTimer3();
CloseUSART();
}
