// Essai afficheur LCD sur picdem2plus en utilisant
// la bibliothque XLCD aprs modification de OpenXLCD et xlcd.h
// R Toquebeuf le 02-12-03


#include <delays.h>
#include "xlcd.h"
#include "ftoa.C"

// Temporisation ncessaires aux composants de la bibliothque XLCD
void DelayFor18TCY(void)
{
        Delay10TCYx(2);
}
 
void DelayPORXLCD(void)
{
 Delay1KTCYx(15);     //Delai de 15 ms
}
 
void DelayXLCD(void)
{
 Delay1KTCYx(20);     //Delai de 20 ms
}


// Programme principal 
void main(void)
{
 char data[20]="bonjour", *pheure[2],*ptemp[30];
 static int heure = 20;
 float temp= 73.225 ;
 
 	OpenXLCD(FOUR_BIT & LINES_5X7 );
	
	while(1)
	{
		while( BusyXLCD() );
		SetDDRamAddr( 0x00 );		  // positionne le curseur
		putsXLCD(data);
		
		while( BusyXLCD() );
		SetDDRamAddr( 0x09 );	
		putcXLCD('B');				  // un caractre
		
		while( BusyXLCD() );
		SetDDRamAddr( 0x0B );
		putsXLCD(itoa(heure,pheure)); // un entier
		
		while( BusyXLCD() );
		SetDDRamAddr( 0x40 );
		putsXLCD(ftoa(temp,ptemp,3,'s'));  //Rel en notation scientifique
		
		while( BusyXLCD() );
		SetDDRamAddr( 0x48 );
		putsXLCD(ftoa(temp,ptemp,3,'f'));   //Rel en notation classique


     };
	
}
