// Test fonction Math
// calcul de exponentielle (base e)
// CD Lyce Fourcade 13120 Gardanne 5/2003
#include <p18f452.h>
#include <stdio.h>
#include "ftoa.c"

char chaine1[15],chaine2[15];

float abs(float f)
{
if (f>=0.0) return (f);
 else return (-1.0*f);
}

float exp(float f)
{
const float eps=0.001 ;
float s=1.0,u=1.0;
int n;
	for (n=1;abs(u)>eps;n++) 
	{
    	u=u*f/n;
    	s+=u;
    }
    return s;
}

void main(void)
{float f,r;
	SPBRG = 25;	/* configure la vitesse (BAUD) 9600 N 8 1*/
    TXSTA = 0x24;                
    RCSTA = 0x90;	/* active l'USART*/
	f=9.0;
	r=exp(f);		// ontilise Heron (pas math.h)
	ftoa(f,(unsigned char *)chaine1,3,'S');
	ftoa(r,(unsigned char *)chaine2,3,'S');
	fprintf(_H_USART,"Racine de %s = %s \n",chaine1,chaine2);
	while(1);
}

