#ifndef __lcd_pd2_h
#define __lcd_pd2_h

/* fonctions tempo pour afficheur LCD sur PICDEM2+*/
//void DelayFor18TCY(void) ;
//void DelayPORXLCD(void);
//void DelayXLCD(void);

/* redirection de putc vers XLCD pour printf sur afficheur LCD*/
int _user_putc(char c);

// initialise l'afficheur pour PICDEM2+ pour printf
void init_printf_LCDPD2(void);

// initialisation afficheur LCD sur PICDEM2+, printf et charge les caracteres personalises
void initLCDPD2(void);

// positionne le curseur en x-y (0<x<15 et 0<y<1
void gotoxy(unsigned char x, unsigned char y);

// efface l'afficheur
void efface(void);

// temporisation 
void tempo(unsigned int t);

// decale l'affichage  gauche si c='g'  droite si c='d'
void decaleLCD(unsigned char c);

// cration caractres perso pour LCD
// les caractres ont les codes ASCII 0  7
// pour afficher le 3ieme : putcXLCD(3);
// necessite fonts.h
void initNouveauxCharacters(void);

// ftoa
unsigned char *ftoa (float x, unsigned char *str,char prec,char format);

#endif
