// CD 01/2005
// test printf sur PICDEM2+ et MCC18 v2.40
#include <p18f452.h>
#include <stdio.h> 		// printf
#include <lcd_pd2.h>	//initLCDPD2, gotoxy, decaleLCD ftoa, etc...

unsigned char c;
int i;
unsigned char tampon[10];
rom const unsigned char chrom[]=" en ROM";
unsigned char chram[]=" en RAM";
unsigned char * pram;
rom unsigned char *prom;
float f;

void touche(void)
{
 while(PORTA & 0x10);
 while(!(PORTA & 0x10));
 efface();
} 


void main(void)
{	
	TRISA=0xFF;		// PORTA en entre pour S2
	initLCDPD2();
	f=5000.0/3.0;
	i=150-200;
	c='A';
	pram=(unsigned char *)0x12AB ;
	prom=(rom unsigned char *)0xAB12;
	while(1)
		{
			gotoxy(0,0);
			printf("TESTS PRINTF");
			gotoxy(0,1);
			printf("appuyez sur S2");
			touche();

			gotoxy(0,0);
			printf("caracteres: %c ",c);
			gotoxy(0,1);
			printf("%d %X %#X ",c,c,c);
			touche();

			gotoxy(0,0);
			printf("integers: %d",i);
			gotoxy(0,1);
			printf("%u %#x",i,i);
			touche();

			gotoxy(0,0);
			printf("binaires: %b",0x1A);
			gotoxy(0,1);
			printf("%010b",0x1A);
			touche();

			gotoxy(0,0);
			printf("Ptr RAM: %p",pram);
			gotoxy(0,1);
			printf("%#010P",pram);
			touche();

			gotoxy(0,0);
			printf("Ptr ROM: %p",prom);
			gotoxy(0,1);
			printf("%#010P",prom);
			touche();

			gotoxy(0,0);
			printf("RAM %s",chram);
			gotoxy(0,1);
			printf("ROM %S",chrom);
			touche();

			gotoxy(0,0);
			ftoa(f,tampon,3,'s');
			printf("Reel: %s",tampon);
			gotoxy(0,1);
			printf("Reel: %s",ftoa(f,tampon,5,'f'));
			touche();

			gotoxy(0,0);
			printf("caract%cres perso",5);
			gotoxy(0,1);
			printf(" %c%c%c%c%c%c%c%c ",0,1,2,3,4,5,6,7);
			touche();
		}
}

